﻿package
{

	import adobe.utils.MMExecute;
	
	import fl.data.DataProvider;
	
	import flash.display.MovieClip;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.external.*;
	import flash.text.TextField;
	import flash.text.TextFormat;

	public class EmbedMetaData extends MovieClip
	{

		//----------------------------------------------------------
		//
		//   Static Property 
		//
		//----------------------------------------------------------

		private static const EMBED_SWF_STR:String = "_EMBED_SWF_";

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function EmbedMetaData()
		{

			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;

			var txtF:TextFormat = new TextFormat();
			txtF.color = 0xFFFFFFF;
			checkBox.setStyle("textFormat", txtF);

			checkBox.addEventListener(Event.CHANGE, checkBox_changeHandler);
			comboBox.addEventListener(Event.CHANGE, comboBox_changeHandler);
			containerProperties.addEventListener(Event.CHANGE, properties_changeHandler);

			setSelectChangeHandler();

			loadData();
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var metadataPropertiesList:Vector.<MetaDataProperties>;

		private var selectedIndex:int;

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		public function setSelectChangeHandler():void
		{
			if (ExternalInterface.available)
			{
				setSelectionCallBack();
				setPublishCallback();
			}
		}
		
		private function setSelectionCallBack():void
		{
			// Register my Callback
			ExternalInterface.addCallback("EmbedMetaDataSelectionChangeCallback", EmbedMetaDataSelectionChangeCallback);
			var JSCode:String = "";
			
			JSCode =  ( <![CDATA[
				function EmbedMetaDataSelectionChangeHandler() 
				{
					if (fl.getSwfPanel("EmbedMetaData", false)) {
						fl.getSwfPanel("EmbedMetaData", false).call("EmbedMetaDataSelectionChangeCallback");
					}
				}
				var handlerIDStr = fl.addEventListener("selectionChanged", EmbedMetaDataSelectionChangeHandler);
			 	if( fl.getSwfPanel("EmbedMetaData", false)) 
				{
					fl.getSwfPanel("EmbedMetaData", false).onCloseScript = function() { fl.removeEventListener("selectionChanged",handlerIDStr);}
				}
			]]> ).toString().replace( /\r/g, "" );

			MMExecute(JSCode);

		}
		
		private function setPublishCallback():void
		{
			var JSCode:String = "";
			
			ExternalInterface.addCallback("EmbedMetaDataPrePublishCallback", EmbedMetaDataPrePublishCallback);

			JSCode =  ( <![CDATA[
				function EmbedMetaDataPrePublishHandler() { 
					if (fl.getSwfPanel("EmbedMetaData", false)) {
						fl.getSwfPanel("EmbedMetaData", false).call("EmbedMetaDataPrePublishCallback"); 
					}
				}
				var handlerIDStr = fl.addEventListener("prePublish", EmbedMetaDataPrePublishHandler);
				if(fl.getSwfPanel('EmbedMetaData', false)) 
				{
					fl.getSwfPanel('EmbedMetaData', false).onCloseScript = function() { fl.removeEventListener("prePublish", handlerIDStr);}
				}

			]]> ).toString().replace( /\r/g, "" );
			
			MMExecute(JSCode);
		}
		
		public function getSelectionValue():void
		{

			var metaDataProperties:MetaDataProperties = metadataPropertiesList[selectedIndex];
			var propertiesLength:int = metaDataProperties.properties.length;

			for (var i:int = 0; i < propertiesLength; i++)
			{
				var property:MetaDataProperty = metaDataProperties.properties[i];

				var renderer:MetaDataRenderer = property.renderer;
				renderer.textValue.text = getValue(property.id);
			}

			checkBox.selected = getBoolFromDocument(EMBED_SWF_STR)
		}

		public function setValue(id:String, dataType:String, value:String):Boolean
		{
			var resultStr:String;
			var result:Boolean;
			var executeStr:String;
			var hereDoc:YuruHereDoc = new YuruHereDoc();
			hereDoc.addValue("id", id);
			hereDoc.addValue("EMBED_SWF_STR",EMBED_SWF_STR);
			
			//	swf埋め込みにこのidを設定する許可を追加する
			executeStr = hereDoc.convert((<![CDATA[
				if (fl.getDocumentDOM() && fl.getDocumentDOM().selection[0] && fl.getDocumentDOM().selection[0] != '[object Shape]')
				{
					fl.getDocumentDOM().selection[0].setPublishPersistentData('#{id}','#{EMBED_SWF_STR}',true);
				}
				]]>).toString() ,true);
			
			MMExecute(executeStr);
			
			hereDoc.addValue("intValue",parseInt(value)+"");
			hereDoc.addValue("doubleValue",parseFloat(value)+"");
			hereDoc.addValue("value",value);
			
			//	関数に渡す変数を設定する
			if (dataType == "integer" && !isNaN(parseInt(value)))
			{
				hereDoc.addValue("funcValue", hereDoc.convert("'#{id}','integer',#{intValue}"));
			}
			else if (dataType == "double" && !isNaN(parseFloat(value)))
			{
				hereDoc.addValue("funcValue", hereDoc.convert("'#{id}','double',#{doubleValue}"));
			}
			else if (dataType == "string")
			{
				hereDoc.addValue("funcValue", hereDoc.convert("'#{id}','string','#{value}'"));
			}
			else{
				MMExecute("fl.trace('unknownData')");
				return false;	
			}
			//	jsflで実際に変数を設定する
			executeStr = hereDoc.convert((<![CDATA[
				if (fl.getDocumentDOM() && fl.getDocumentDOM().selection[0] && fl.getDocumentDOM().selection[0] != '[object Shape]')
				{
					fl.getDocumentDOM().selection[0].setPersistentData(#{funcValue});
				}
				]]>).toString() ,true);
			resultStr = MMExecute(executeStr);
			
			return true;
		}

		public function getValue(id:String):String
		{
			var result:String;
			var hereDoc:YuruHereDoc = new YuruHereDoc();
			hereDoc.addValue("id", id);
			
			//	jsflから変数を取得する
			var execute:String = hereDoc.convert(
					(<![CDATA[
						if (fl.getDocumentDOM() && fl.getDocumentDOM().selection[0] && fl.getDocumentDOM().selection[0] != '[object Shape]') 
						{
							fl.getDocumentDOM().selection[0].getPersistentData('#{id}')
						}
						]]>
					).toString() ,true)
				
			result = MMExecute(execute);

			return (result == "undefined") ? "" : result;
		}

		public function EmbedMetaDataPrePublishCallback():void
		{
			//特に何もしなくて良い
			//getSelectionValue();
		}

		public function EmbedMetaDataSelectionChangeCallback():void
		{
			getSelectionValue();
		}

		public function properties_changeHandler(event:Event):void
		{

			var metaDataProperties:MetaDataProperties = metadataPropertiesList[selectedIndex];

			var propertiesLength:int = metaDataProperties.properties.length;

			for (var i:int = 0; i < propertiesLength; i++)
			{
				var property:MetaDataProperty = metaDataProperties.properties[i];
				var renderer:MetaDataRenderer = property.renderer;
				setValue(property.id, property.datatype, renderer.textValue.text);
			}
		}

		//	変数設定用のファイルを開きます。
		//	今回はコンフィグディレクトリ/WindowSWF/EmbedMetaData/metadata_variables.txt というファイル固定です。
		//	データが無いときはエラーが出るなど、不安定になる可能性があるので注意してください。
		public function loadData():void
		{
			var uri:String = MMExecute('fl.configURI+"WindowSWF\/EmbedMetaData\/metadata_variables.txt";');
			var str:String = MMExecute('FLfile.read(\"' + uri + '"\);');
			var arr:Array = str.split("\n")

			var dp:DataProvider = new DataProvider();

			metadataPropertiesList = new Vector.<MetaDataProperties>();

			var metaDataProperties:MetaDataProperties = null;
			for (var i:int = 0; i < arr.length; i++)
			{
				if (arr[i].length >= 2 && "#" == arr[i].substr(0, 1))
				{
					metaDataProperties = new MetaDataProperties();
					metadataPropertiesList.push(metaDataProperties);
					metaDataProperties.id = trim(arr[i].substr(1));
					metaDataProperties.properties = new Vector.<MetaDataProperty>();
					dp.addItem({label: arr[i].substr(1)});
				}

				var property:Array = arr[i].split(",");
				if (metaDataProperties != null && property.length == 2)
				{
					var metaDataProperty:MetaDataProperty = new MetaDataProperty();
					metaDataProperty.id = trim(property[0]);
					metaDataProperty.datatype = trim(property[1]);
					metaDataProperty.update();
					metaDataProperties.properties.push(metaDataProperty);
				}

			}
			selectedIndex = 0;

			comboBox.dataProvider = dp;
			
			if( metadataPropertiesList.length >= 1)
				setupData(selectedIndex);
		}

		public function trim(str)
		{
			var regexHead:RegExp = new RegExp('^[ \n\r]*');
			var regexFoot:RegExp = new RegExp('[ \n\r]*$');

			return str.replace(regexHead, '').replace(regexFoot, '');
		}

		public function setupData(selectedIndex:int):void
		{

			containerProperties.removeChildren();

			var metaDataProperties:MetaDataProperties = metadataPropertiesList[selectedIndex];
			var propertiesLength:int = metaDataProperties.properties.length;

			for (var i:int = 0; i < propertiesLength; i++)
			{
				var renderer:MetaDataRenderer = metaDataProperties.properties[i].renderer;
				containerProperties.addChild(renderer);
				renderer.y = i * 20;
			}
		}

		public function checkBox_changeHandler(event:Event)
		{
			var embedSWF:Boolean = checkBox.selected;
			var jsCode:String = "";
	
			var hereDoc:YuruHereDoc = new YuruHereDoc();
			hereDoc.addValue("EMBED_SWF_STR",EMBED_SWF_STR);
			hereDoc.addValue("embedSwf",embedSWF);
			
			if (embedSWF)
			{
				var playerVersion:String = MMExecute("if (fl.getDocumentDOM()) fl.getDocumentDOM().getPlayerVersion();");
				if (playerVersion != "FlashPlayer11.6")
				{
					var resStr:String = MMExecute("confirm('Requires Flash Player 11.6 or greater. Set player to 11.6?');");
					if (resStr == "true")
						MMExecute("if (fl.getDocumentDOM()) fl.getDocumentDOM().setPlayerVersion('FlashPlayer11.6');");
				}

			}
			
			jsCode = hereDoc.convert( "if (fl.getDocumentDOM()) fl.getDocumentDOM().setPublishDocumentData( '#{EMBED_SWF_STR}', #{embedSwf} )" );
			
			MMExecute(jsCode);
			MMExecute("fl.trace(\"embedSWF:" + embedSWF + " \");");
		}

		public function getBoolFromDocument(pubFormat:String):Boolean
		{
			var resultStr:String;
			var result:Boolean;

			resultStr = MMExecute("if (fl.getDocumentDOM()) fl.getDocumentDOM().getPublishDocumentData('" + pubFormat + "');");
			result = (resultStr == "true");

			return (result);
		}

		public function comboBox_changeHandler(event:Event)
		{
			selectedIndex = comboBox.selectedIndex;
			setupData(selectedIndex);
			getSelectionValue()
		}
	}
}

import flash.display.Sprite;
import flash.text.TextField;

internal class MetaDataProperties
{

	//----------------------------------------------------------
	//
	//   Constructor 
	//
	//----------------------------------------------------------

	public function MetaDataProperties():void
	{

	}

	//----------------------------------------------------------
	//
	//   Property 
	//
	//----------------------------------------------------------

	public var id:String;
	public var properties:Vector.<MetaDataProperty>;
}

internal class MetaDataProperty
{

	//----------------------------------------------------------
	//
	//   Constructor 
	//
	//----------------------------------------------------------

	public function MetaDataProperty():void
	{
		renderer = new MetaDataRenderer();
	}

	//----------------------------------------------------------
	//
	//   Property 
	//
	//----------------------------------------------------------

	public var datatype:String;

	public var id:String;

	public var renderer:MetaDataRenderer;

	//----------------------------------------------------------
	//
	//   Function 
	//
	//----------------------------------------------------------

	public function update():void
	{
		renderer.labelID.text = id;
		renderer.labelDataType.text = datatype;
		switch (datatype)
		{
			case "string":
			{
				renderer.textValue.restrict = null;
				break;
			}
			case "double":
			{
				renderer.textValue.restrict = "-0-9.";
				break;
			}
			case "integer":
			{
				renderer.textValue.restrict = "-0-9";
				break;
			}
		}
	}
}
